import { BaseView } from "./base-view";
import { PouchService } from "../services/pouch-service";
import { Observable } from "rxjs/Observable";

export abstract class BaseDetailsView<T> extends BaseView<T> {

    item: T;
    action: string;

    constructor(c: { new (): T; }, item?: T) {
        super(c, PouchService);
        
        this.item = item;
        this.action = item ? "to_update" : "to_create";
    }

    /**
     * 
     */
    getItem(): T {
        return this.item;
    }

    /**
     * 
     * @param item 
     */
    setItem(item: T) {
        this.item = item;
    }

    /**
     * 
     */
    getAction(): string {
        return this.action;
    }

    /**
     * 
     * @param action 
     */
    setAction(action: string): void {
        this.action = action;
    }

    /**
     * 
     */
    itemExists(): boolean {
        return !!Object.keys(this.getItem()).length;
    }

    /**
     * 
     */
    cleanItem(): void {
        this.setItem(Object.create(null));
    }

    /**
     * 
     * @param data 
     */
    performSave(): Observable<any> {
        this.setItem(Object.assign(this.getItem(), { odoo_model: super.getModelName(), odoo_status: this.getAction() }));
        return super.getInjectable(PouchService).save(this.getItem());
    }
}